#include <srrno.h>
#include <string.h>

#include "jy_sg.h"


static SgError theErrorValue = SG_ERR_NONE;
static int     theErrnoValue = 0;
int	       errnoIsInteresting;


enum SgError 
sg_get_error(void)
{
  return theErrorValue;
}

int 
sg_is_errno_interesting(void)
{
  return errnoIsInteresting;
}

int 
sg_get_error_errno_value(void)
{
  if (errnoIsInteresting)
    return theErrnoValue;
  else
    return 0;
}

void 
sg_clear_error(void)
{
  theErrorValue = SG_ERR_NONE;
  theErrnoValue = 0;
  errnoIsInteresting = 0;
}

void 
sg_set_error(enum SgError err)
{
  theErrorValue = err;	/* errno may not be writable ! */
  theErrnoValue = 0;
  errnoIsInteresting = 0;
}

void 
sg_set_syscall_error(enum SgError err)
{
  theErrnoValue = errno;
  errnoIsInteresting = 1;
  theErrorValue = err;
}

static const char *sg_errlist[] =
{
  "unknown (no?) error",
  "Can\'t open port device",
  "Can\'t detect the DSP",
};

static char errbuf[100];

const char *
sg_get_error_message(void)
{
  strcpy(errbuf, sg_errlist[theErrorValue])
  if (errnoIsInteresting)
    strcat(errbuf, strerror(theErrnoValue));
  return errbuf;
}


  
